<?php

// PatientDemographic Constants
define('sex',['Feminino','Masculino']);
define('occupation_state',['Ativo(a)','Aposentado(a)','Exerce atividades do lar','Desempregado','Auxílio Doença']);
define('marital_state',['Solteiro','Casado(a) ou em união consensual','Viúvo(a)','Separado ou Divorciado(a)']);
define('siblings',['0','1 a 3','Mais de 3']);
define('school',['<9 anos','9 a 12 anos','12 a 16 anos','>16 anos']);

// PatientClinical Constants
define('hypertension',['<1 ano','1 a 5 anos','6 a 10 anos','>10 anos']);
define('year_hospital',['1','2 a 3','≥ 4']);
define('research_hospital',['1','2 a 3','≥ 4']);
define('drugs_in_use',['Não usa','1','2 a 3','4 a 5','> de 5']);
define('depression',['Sim','Não']);
define('risk',['Baixo','Moderado','Alto','Muito alto risco']);

define('day_time',['Manhã','Tarde','Manhã,Tarde','Noite','Manhã,Noite','Tarde,Noite','Manhã,Tarde,Noite']);

define('group_type',['Intervenção','Controle']);

// PatientHabits Constants
define('smoke',['Sim','Não','Ex-Tabagista']);
define('alcohol',['Não ingere','Ingesta Moderada','Ingesta mais do que moderada']);

// PatientExam Constants
define('imc',['Baixo Peso: (< 18,5 Kg/m²)','Peso Saudável: (18,5 a 24,9 Kg/m²)','Sobrepeso: (25,0 a 29,9 Kg/m²)','Obesidade: (≥ 30 Kg/m²)']);
define('abs_circle_type',['Normal','Acima']);
define('blood_pressure_type',['Normal (≤120/≤80 mmHg)','Pré-hipertensão (121-139/81-89 mmHg)','Estágio 1 (140–159/90–99 mmHg)','Estágio 2 (160–179/100–109 mmHg)','Estágio 3 (≥ 180/ ≥ 110 mmHg)','HA isolada(≥ 140 < 90 mmHg)']);
define('itc',['Normal = acima de 0,90','Obstrução leve = 0,71–0,90','Obstrução moderada=0,41–0,70','Obstrução grave = 0,00–0,40']);

// PatientQuality Constants
define('questions',['Não, absolutamente','Sim, um pouco','Sim, bastante', 'Sim, muito']);

//Column Map
define('COLUMNS',[
	'hypertension' => 'P12',
	'depression' => 'P17',
	'risk' => 'P18',
	'research_hospital' => 'P14',
	'research_hospital_description' => 'P14.1',
	'year_hospital' => 'P13',
	'year_hospital_description' => 'P13.1',
	'drugs_in_use' => 'P15',
	'total_time' => 'TEMPO',
	'age' => 'P1',
	'sex' => 'P2',
	'occupation_state' => 'P6',
	'occupation' => 'P6.TEXTO',
	'marital_state' => 'P3',
	'siblings' => 'P4',
	'school' => 'P5',
	'roommates' => 'P7',
	'family_incomes' => 'P8',
	'day_time' => 'M/T/N',
	'ammount' => 'Dose',
	'usage_time'=> 'Tempo de uso',
	'weight' => 'P23',
	'height' => 'P24',
	'imc' => 'P25',
	'imc_value' => 'P25',
	'abs_circle' => 'P26',
	'abs_circle_type' => 'P26.1/P26.2',
	'blood_pressure_systole' => 'P27/Sistole',
	'blood_pressure_diastole' => 'P27/Diastole',
	'itc' => 'P28',
	'itc_value' => 'P28',
	'diagnosis' => 'Diagnóstico',
	'prescription' => 'Planejamento',
	'evolution' => 'Avaliação',
	'history' => 'Histórico',
	'exam' => 'Exame Físico',
	'smoke' => 'P19',
	'smoke_time' => 'P19.TEMPO',
	'smoke_amount' => 'P19.QUANTIDADE',
	'alcohol' => 'P20',
	'alcohol_time' => 'P20.TEMPO',
	'in_natura' => 'P21.1',
	'min_processed' => 'P21.2',
	'processed' => 'P21.3',
	'ultra_processed' => 'P21.4',
	'moderated_sports_week' => 'P22.1/Vezes',
	'moderated_sports_time' => 'P22.1/Tempo',
	'high_sports_week' => 'P22.2/Vezes',
	'high_sports_time' => 'P22.2/Tempo',
	'physical_activity' => 'P22.3',
	'q1' => 'Qualidade.P1',
	'q2' => 'Qualidade.P2',
	'q3' => 'Qualidade.P3',
	'q4' => 'Qualidade.P4',
	'q5' => 'Qualidade.P5',
	'q6' => 'Qualidade.P6',
	'q7' => 'Qualidade.P7',
	'q8' => 'Qualidade.P8',
	'q9' => 'Qualidade.P9',
	'q10' => 'Qualidade.P10',
	'q11' => 'Qualidade.P11',
	'q12' => 'Qualidade.P12',
	'q13' => 'Qualidade.P13',
	'q14' => 'Qualidade.P14',
	'q15' => 'Qualidade.P15',
	'q16' => 'Qualidade.P16',
	'q17' => 'Qualidade.P17',
	'id' => 'Identificação',
	'patient_id' => 'Paciente',
	'user_create_id' => 'Responsável',
	'create_date' => 'Data Criação',
	'upload_date' => 'Data Upload',
	'points' => 'Pontos na Escala',
	'DrugName' => 'Medicamento',
	'blood_pressure_type' => 'P27',
	'Cid10' => 'Nome Cid10',
	'forms' => 'Total de Formulários',
	'group_type' => 'Grupo'
]);