<?php
class DumpController extends \Phalcon\Mvc\Controller
{

	public function export(){

        require_once(__DIR__.'/../constants/FormConstants.php');

		$Forms = PatientForm::find([
			'order' => 'create_date desc'
		],false);
        $object = array();
        $object = $Forms->toArray();
        $i = 0;
		foreach ($Forms as $Form){
            //One
            $object[$i]['Patient'] = Patient::findFirst(array(
                'id = ?1',
                'bind' => array( 1 => $object[$i]['patient_id'] )
            ),false);
            $object[$i]['Patient'] = $this->NumberToString($object[$i]['Patient']);

			$object[$i]['PatientHabits'] = PatientHabits::findFirst(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            $object[$i]['PatientHabits'] = $this->NumberToString($object[$i]['PatientHabits']);

            $object[$i]['PatientExam'] = PatientExam::findFirst(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            $object[$i]['PatientExam'] = $this->NumberToString($object[$i]['PatientExam']);

            $object[$i]['PatientDemographic'] = PatientDemographic::findFirst(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            $object[$i]['PatientDemographic'] = $this->NumberToString($object[$i]['PatientDemographic']);

            $object[$i]['PatientClinical'] = PatientClinical::findFirst(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            $object[$i]['PatientClinical'] = $this->NumberToString($object[$i]['PatientClinical']);

            $object[$i]['PatientQuality'] = PatientQuality::findFirst(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            $object[$i]['PatientQuality'] = $this->QuestionsToString($object[$i]['PatientQuality']);

            //Many
            $PatientComorbids = PatientComorbid::find(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            foreach($PatientComorbids as $Comorbid){
                $Cid10 = Cid10::FindFirst($Comorbid->cid10_id,true);
                $Comorbid->Cid10 = $Cid10->description;
                $object[$i]['PatientComorbid'][] = $this->NumberToString($Comorbid);
            }

            $PatientComplications = PatientComplication::find(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            foreach($PatientComplications as $Complication){
                $Cid10 = Cid10::FindFirst($Complication->cid10_id,true);
                $Complication->Cid10 = $Cid10->description;
                $object[$i]['PatientComplication'][] = $this->NumberToString($Complication);
            }

            $PatientDrugs = PatientDrug::find(array(
                'patient_form_id = ?1',
                'bind' => array( 1 => $object[$i]['id'] )
            ),false);
            foreach($PatientDrugs as $Drug){
                $DrugName = Drug::FindFirst($Drug->drug_id,true);
                $Drug->DrugName = $DrugName->name;
                $object[$i]['PatientDrug'][] = $this->NumberToString($Drug);
            }
            $i++;
		}
        $csv = '';
        $csv .= $this->ColumnNames($object[0]) . "\n";
        foreach ($object as $array){
            $csv .= $this->ObjectToCSV($array) . "\n";
        }
        $filename = '/tmp/pequisas_'.date('YmdHis').'.csv';
        $fh = fopen($filename,'w');
        if ($fh){
            fwrite($fh,$csv);
            fclose($fh);
            $file = new FilePlugin(null,$this->config->amazon->key,$this->config->amazon->secret);
            $status = $file->upload($filename,false,'Pesquisa_extraida_em_'.date('dmY').'.csv');

            if ($status){
                return ResponseHandler::get($this,array('url' => $status['ObjectURL']));
            } else {
                return ResponseHandler::get($this,array('error' => 'Erro ao enviar o arquivo'));
            }
        } else {
            return ResponseHandler::get($this,array('error' => 'Erro ao criar o arquivo'));
        }
	}


	private function ColumnNames($object){
		//Nome da variavel convertido para nome de coluna legivel do excel
		//E.g. array('itc' => 'Indice Tornozelo-braquial');
        $line = '';
        foreach($object as $name => $value){
            if (is_array($value)){
                $line .= $this->ColumnNames($value);
            } else {
                if (COLUMNS[$name]){
                    $line .= COLUMNS[$name].';';
                } else {
                    $line .= $name.';';
                }
            }
        }
        return $line;
	}

    private function ObjectToCSV($object){
        $line = '';
        foreach($object as $o){
            if (is_array($o)){
                $line .= $this->ObjectToCSV($o);
            } else {
                $line .= $o.';';
            }
        }
        return $line;
    }

	private function NumberToString($object){
        $formated_object = array();
        foreach ($object as $name => $value){
            if ($name != 'patient_form_id'){
                if (defined($name)){
                    $formated_object[$name] = constant($name)[$value - 1];
                } else {
                    $formated_object[$name] = $value;
                }
            }
        }
        return $formated_object;
	}

    private function QuestionsToString($object){
        $formated_object = array();
        $i = 0;
        foreach ($object as $name => $value){
            // Só preenche se o objeto for definido, os outros objetos retornam vazio
            if ($name != 'patient_form_id'){
                $i++;
                $formated_object['q'.$i] = questions[$value];
            }
        }
        return $formated_object;
    }

}