<?php

class LoginController extends \Phalcon\Mvc\Controller
{

    public function get(){
    	$apikey = Apikey::findFirst(
							array(
								"user_id = ?1 and device=?2 and valid='1' and generate_date+?3 >= ?4",
								"bind" => array(1 => $this->session->get('id'), 2 => $this->request->getUserAgent(), 3 => $this->config->api->keytimeout, 4 => time()),
								"columns" => "public_key"
							));
		if (!$apikey){
			$apikey = new Apikey();
			$apikey->public_key = base64_encode(time().'X'.$this->session->get('id'));
			$apikey->private_key = hash_hmac('md5',$apikey->public_key,$this->config->keychain->apikey);
			$apikey->user_id = $this->session->get('id') ;
			$apikey->device = $this->request->getUserAgent();
			$apikey->save();
		}
        return ResponseHandler::get($this,[
            'id' => $this->session->get('id'),
            'apikey' => $apikey->public_key
        ]);
    }

}

