<?php

class PasswordRecoveryController extends \Phalcon\Mvc\Controller
{

    public function post(){
        // Gera link da nova senha e envia para o e-mail
        $request = $this->di->get('request')->getJsonRawBody();
        $translate = $this->di->get('translation');

        $user = User::findFirst(array(
                                    "email = ?1 and valid=1",
                                    "bind" => array(1 => $request->email)
                                ),false);

        if ($user){
            $password_recovery = PasswordRecovery::findFirst(array("user_id=?1 and reset_date is null and expire_date > ?2",
                                                    "bind" => array(1 => $user->id, 2 => time())
                                            ),true);
            if (!$password_recovery){
                $password_recovery = new PasswordRecovery();
                $password_recovery->user_id = $user->id;
                $password_recovery->expire_date = strtotime("+5 minutes");
                if ($password_recovery->save()){
                    $email_plugin = new MailPlugin();
                    $data = ['FIRSTNAME' => $user->Person->name,'LINK' => $this->config->url->host.$this->router->getRewriteUri().'/'.$password_recovery->id."/".SecretUrlPlugin::saveSecret($password_recovery->id,$this->config->keychain->password)];
                    if ( $email_plugin->send($user->Person->name,$user->email,MailConstants::PASSWORD_RECOVERY,$data) ){
                        return ResponseHandler::post($this,array('message' => $translate->t('success.password_recovery')));
                    } else {
                        return ResponseHandler::post($this,false,false,array('error' => $translate->t('error.email.cantsend')));
                    }
                } else {
                    foreach($password_recovery->getMessages() as $m){
                        $r['error'][] = (string) $m;
                    }
                    return ResponseHandler::post($this,false,false,$r);
                }
            } else {
                return ResponseHandler::post($this,false,false,array('error' => $translate->t('retry.5minutes')));
            }
        } else {
            return ResponseHandler::post($this,false,false,array('error' => $translate->t('notfound.email')));
        }
        return ResponseHandler::post($this,false,false,array('error' => $translate->t('error.unknown')));
    }

    public function get($id,$secret){
    	// Pega os dados do usuario que a senha será resetada, para exibir na tela
        if ( SecretUrlPlugin::loadSecret($id,$secret,$this->config->keychain->password) ){
            $pwr = PasswordRecovery::findFirst(array("reset_date is null and id=?1","bind"=>array(1 => $id)),false);
            if ($pwr){
                $pwr->clicked = 1;
                $pwr->save();
                if (time() < $pwr->expire_date){
                    $user = User::findFirst(
                                    array(
                                        "id = ?1 and valid=1",
                                        "bind" => array(1 => $pwr->user_id)
                                    ),false);
                    $r['first_name'] = $user->first_name;
                    $r['last_name'] = $user->last_name;
                    $r['email'] = $user->email;
                    if ($user){
                        return ResponseHandler::get($this,$r);
                    } else {
                        return ResponseHandler::get($this,false);
                    }
                }
            }
        }
        return ResponseHandler::get($this,false);
    }

    public function put($id,$secret){
    	// Recebe os dados e reseta a senha
        $request = $this->di->get('request')->getJsonRawBody();
        $translate = $this->di->get('translation');
        if ($request){
            if ( SecretUrlPlugin::loadSecret($id,$secret,$this->config->keychain->password) ){
                $pwr = PasswordRecovery::findFirst(array("reset_date is null and id=?1","bind"=>array(1 => $id)),false);
                if ($pwr){
                    if (time() < $pwr->expire_date){
                        $user = User::findFirst($pwr->user_id,false);
                        $user->skipRequest = true;
                        $user->password = sha1($request->password);
                        if ( $user->save() ){
                            $pwr->reset_date = time();
                            if ( $pwr->save() ){
                                return ResponseHandler::put($this,false,true);
                            } else {
                                foreach($pwr->getMessages() as $m){
                                    $r['error'][] = (string) $m;
                                }
                                return ResponseHandler::put($this,false,false,$r);
                            }
                        } else {
                            foreach($pwr->getMessages() as $m){
                                $r['error'][] = (string) $m;
                            }
                            return ResponseHandler::put($this,false,false,$r);
                        }
                    } else {
                        return ResponseHandler::put($this,false,true,array('error' => $translate->t('expired.url')));
                    }
                } else {
                    return ResponseHandler::put($this,false,false);
                }
            } else {
                return ResponseHandler::put($this,false,false,array('error' => $translate->t('error.invalidurl')));
            }
        } else {
            return ResponseHandler::put($this,false,false,array('error' => $translate->t('error.norequest')));
        }
        return ResponseHandler::put($this,false,false,array('error' => $translate->t('error.unknown')));
    }

}

