<?php
class StatisticsController extends \Phalcon\Mvc\Controller
{
	//QL => Qualitativo, QT => Quantitativo
	private $PatientDemographic = array(
		'age' => 'QL',
		'siblings' => 'QL',
		'roommates' => 'QL',
		'family_incomes' => 'QL',
		'sex' => 'QT',
		'occupation_state' => 'QT',
		'marital_state' => 'QT',
		'school' => 'QT'
	);

	private $PatientHabits = array(
		'in_natura' => 'QL',
		'min_processed' => 'QL',
		'processed' => 'QL',
		'ultra_processed' => 'QL',
		'smoke' => 'QT',
		'smoke_time' => 'QL',
		'smoke_amount' => 'QL',
		'alcohol' => 'QT',
		'alcohol_time' => 'QL',
		'moderated_sports_week' => 'QL',
		'moderated_sports_time' => 'QL',
		'high_sports_week' => 'QL',
		'high_sports_time' => 'QL',
		'physical_activity' => 'QT'
	);

	private $PatientExam = array(
		'weight' => 'QL',
		'height' => 'QL',
		'imc_value' => 'QL',
		'abs_circle' => 'QL',
		'itc_value' => 'QL',
		'imc' => 'QT',
		'abs_circle_type' => 'QT',
		'itc' => 'QT'
	);

	private $PatientQuality = array(
		'question1' => 'QT',
		'question2' => 'QT',
		'question3' => 'QT',
		'question4' => 'QT',
		'question5' => 'QT',
		'question6' => 'QT',
		'question7' => 'QT',
		'question8' => 'QT',
		'question9' => 'QT',
		'question10' => 'QT',
		'question11' => 'QT',
		'question12' => 'QT',
		'question13' => 'QT',
		'question14' => 'QT',
		'question15' => 'QT',
		'question16' => 'QT',
		'question17' => 'QT'
	);

	private $PatientClinical = array(
		'year_hospital' => 'QT',
		'research_hospital' => 'QT'
	);

	private $PatientDrug = array(
		'drug_id' => 'QT'
	);

	private $PatientComorbid = array(
		'cid10_id' => 'QT'
	);


	private $models = ['PatientDemographic','PatientHabits','PatientExam','PatientQuality','PatientDrug','PatientComorbid','PatientClinical'];

	public function get(){
		require_once(__DIR__.'/../constants/FormConstants.php');
		$r = array();
		$i = 0;
		foreach ($this->models as $model_name){
			$dados = $model_name::Find([ ], false)->toArray();
			foreach ($this->$model_name as $column => $type){
				if ($type == 'QL'){
					$r[$i]['type'] = 'QL';
					$r[$i]['name'] = $this->ColumnNames($column);
					$r[$i]['data'] = $this->qualitativo($dados,$column);
				} else {
					$r[$i]['type'] = 'QT';
					$r[$i]['name'] = $this->ColumnNames($column);
					$r[$i]['data'] = $this->quantitativo($dados,$column);
				}
				$i++;
			}
		}
    	return ResponseHandler::get($this,$r);
    }

    private function qualitativo($array,$key){
    	$data = new Math(self::MathArray($array,$key));
    	$r['avg'] = $data->media();
    	$r['median'] = $data->mediana();
    	$r['min'] = $data->min();
    	$r['max'] = $data->max();
    	$r['desvio'] = $data->desvioPadrao();
		return $r;
    }

    private function quantitativo($array,$key){
    	$data = new Math(self::MathArray($array,$key));
    	foreach ($data->porcentagem() as $k => $v){
    		$r[$k]['valor'] = $k;
    		$r[$k]['porcentagem'] = $v;
    	}
		foreach ($data->frequencia() as $k => $v){
    		$r[$k]['freq'] = $v;
    	}
		return $r;
    }

    private static function MathArray($array, $index){
    	$matharray = array();
    	foreach ($array as $arr){
    		if ( isset($arr[$index]) ){
    			$matharray[] = $arr[$index];
    		}
    	}
    	return $matharray;
    }

    private function ColumnNames($name){
	    if (COLUMNS[$name]){
	        $line = COLUMNS[$name];
	    } else {
	        $line = $name;
	    }
        return $line;
	}
}