<?php

class UserController extends RestController
{

    /**
     * Defines which columns will be returned by the REST
     */
    public static $_columns = 'id,email,person_id';

    /**
     * If defined, specifies if the method is restricted to admin or not
     */
    public static $restricted = array(
        'post' => true,
        'delete' => true
    );

    /**
     * Do we cache this response?
     */
    protected $cacheable = false;

    /**
     * Allows search by and partial by fields
     */
    public static $_allow = array(
        'search' => array('id','email'),
        'partials' => array('id','email')
    );

    public function put($id = null){
        $request = $this->di->get('request')->getJsonRawBody();
        $object = User::findFirst($id,false);
        if ($object && $request){
            $object->skipRequest = true;

            $person = Person::findFirst($object->person_id,false);
            $person->name = $request->Person->name;
            $person->born_date = $request->Person->born_date;
            $person->phone = $request->Person->phone;
            $person->address = $request->Person->address;
            $person->neighborhood = $request->Person->neighborhood;
            $person->address_number = $request->Person->address_number;
            $person->User->email = $request->email;

            if ($person->save()){
                $updated_object = User::findFirst(array( "id =?1",
                                                    "bind" => array( 1 => $object->id),
                                                    "columns" => UserController::$_columns),true);
                return ResponseHandler::put($this,$updated_object,$object->id);
            } else {
                foreach($object->getMessages() as $m){
                    $err['error'][] = (string) $m;
                }
                return ResponseHandler::put($this,false,$object->id,$err);
            }
        } else {
            return ResponseHandler::put($this,false,false);
        }
    }

}

