<?php

use Phalcon\Mvc\Micro\MiddlewareInterface;

/**
 * AuthorizationMiddleware
 *
 * Handles REST Authorizations
 */
class AuthorizationMiddleware implements MiddlewareInterface
{
    public function call(Phalcon\Mvc\Micro $app)
    {
		$AclPlugin = new AclPlugin();
		if ( $app->router->getRewriteUri() == '/login' ){
			if ($app->request->getServer('PHP_AUTH_USER') && $app->request->getServer('PHP_AUTH_PW')){
				if ( Auth::login($app->request->getServer('PHP_AUTH_USER'), $app->request->getServer('PHP_AUTH_PW'),$app) ) { 
	                if ( $AclPlugin->getPermission($app) ){
	                    return true;
	                }
	                $app->response
	                    ->setStatusCode(403, 'Forbidden');
	            } else {
	                $app->response
	                    ->setStatusCode(401, 'Unauthorized');
	            }
			} else {
				$app->response
	                    ->setStatusCode(403, 'Forbidden');
			}
		} else {
			if ($app->request->getHeader('apikey')){
	            if ( Auth::apiKey($app->request->getHeader('apikey'),$app) ) { 
	                if ( $AclPlugin->getPermission($app) ){
	                    return true;
	                }
	                $app->response
	                    ->setStatusCode(403, 'Forbidden');
	            } else {
	                $app->response
	                    ->setStatusCode(401, 'Unauthorized');
	            }
	        } else {
	            if ( $AclPlugin->getPermission($app) ){
	                return true;
	            }
	            $app->response
	                    ->setStatusCode(403, 'Forbidden');
	        }
		}
        $app->response->send();
        return false;
    }
}