<?php
use Phalcon\Mvc\Model\Behavior\SoftDelete;
class Apikey extends \Phalcon\Mvc\Model
{
    /**
     *
     * @var string
     */
    public $user_id;

    /**
     *
     * @var string
     */
    public $public_key;

    /**
     *
     * @var string
     */
    public $private_key;

    /**
     *
     * @var string
     */
    public $device;

    /**
     *
     * @var string
     */
    public $generate_date;

    /**
     *
     * @var string
     */
    public $valid;

    /**
     * Initialize method for model.
     */
    public function initialize()
    {
        $this->belongsTo('user_id', 'User', 'id', array('alias' => 'User'));

        $this->addBehavior(
            new SoftDelete(
                array(
                    'field' => 'valid',
                    'value' => ModelConstants::DELETED
                )
            )
        );
    }

    /**
     * Returns table name mapped in the model.
     *
     * @return string
     */
    public function getSource()
    {
        return 'apikey';
    }
    
    public function beforeValidationOnCreate(){
        $this->valid = 1;
        $this->generate_date = time();
    }

}
