<?php
use \Phalcon\Mvc\Model\Message as Message;
class ModelBase extends \Phalcon\Mvc\Model
{

	public static $Relations = [
    ];

    public static $clearCache = [
	];

    public static $forbiddenFields = [
    ];

    /**
	 * Level-up early implementation of a cache. 
	 * Everytime a related model is updated we need to clean the cache so we dont get wrong infos.
     */

    private function cleanUpCache($cache){
    	foreach (static::$clearCache as $relation ){
    		if ( $cacheKeys = $cache->queryKeys(md5($relation.'Controller')) ){
    			foreach ($cacheKeys as $cleanUpKey){
    				$cache->delete($cleanUpKey);
    			}
    		}
    	}
    }

    /**
     * After every record update we clean the cache. Do NOT override this function without calling it back
     */
    public function afterSave()
    {
    	$this->cleanUpCache($this->getDI()->get('caching'));
    }

    public static function findFirst($parameters = null,$iterate = false)
    {
        $value = parent::findFirst($parameters);
        if (!$iterate)
            return $value;

        if ($value){
            $r = $value->toArray();
            foreach (static::$Relations as $relation => $key){
                $controller_name = $relation.'Controller';
                $r[$relation] = $relation::findFirst(array(
                        "id = ?1",
                        "bind" => array(1 => $value->$key),
                        "columns" => $controller_name::$_columns),true);
            }
            return (object) $r;
        } else {
            return null;
        }
    }

	public static function find($parameters = null,$iterate = false)
    {
        $array = parent::find($parameters);
        if (!$iterate)
            return $array;
        if ($array){
            $i = 0;
            foreach($array as $value){
                $r[$i] = $value->toArray();
                foreach (static::$Relations as $relation => $key){
                  $controller_name = $relation.'Controller';
                  $r[$i][$relation] = $relation::findFirst(array(
                              "id = ?1",
                              "bind" => array(1 => $value->$key),
                              "columns" => $controller_name::$_columns),true);
                }
                $i++;
            }
            return $r;
        } else {
            return null;
        }
    }

    public function validateRequest($request,$translate){
        foreach ( static::$forbiddenFields as $field ){
            if ( isset($request->$field) ){
                $this->appendMessage(new Message($translate->t('error.invalidrequest')));
                return false;
            }
        }
        return true;
    }
}