<?php

use Phalcon\Validation\Validator\PresenceOf as PresenceOf;
use \Phalcon\Mvc\Model\Message as Message;
use Phalcon\Validation;

class PatientDemographic extends ModelBase
{
    /**
     * Handle nested results
     */
    public static $Relations = [
        'PatientForm' => 'patient_form_id'
    ];

    /**
     * Clear cache for related models
     */
    // public static $clearCache = [
    //  'ModelRelated'
    // ];

    public static $forbiddenFields = [
        'patient_form_id'
    ];

    public $patient_form_id;

    public $age;

    public $sex;

    public $occupation;

    public $occupation_state;

    public $marital_state;

    public $siblings;

    public $school;

    public $roommates;

    public $family_incomes;

    public function validation(){

        $validator = new Validation();
        $translate = $this->di->get('translation');

        //@TODO Implementar validações
        return $this->validate($validator);
    }

    /**
     * Initialize method for model.
     */
    public function initialize()
    {
        $this->belongsTo('patient_form_id', 'PatientForm', 'id', array('alias' => 'PatientForm'));
    }

    /**
     * Returns table name mapped in the model.
     *
     * @return string
     */
    public function getSource()
    {
        return 'patient_demographic';
    }

}
