<?php

use Phalcon\Validation\Validator\PresenceOf as PresenceOf;
use \Phalcon\Mvc\Model\Message as Message;
use Phalcon\Validation;

class PatientDrug extends ModelBase
{
    /**
     * Handle nested results
     */
    public static $Relations = [
        'PatientForm' => 'patient_form_id',
        'Drug' => 'drug_id'
    ];

    /**
     * Clear cache for related models
     */
    // public static $clearCache = [
    //  'ModelRelated'
    // ];

    public static $forbiddenFields = [
        'patient_form_id'
    ];

    public $patient_form_id;

    public $drug_id;

    public $day_time;

    public $ammount;

    public $usage_time;


    public function validation(){

        $validator = new Validation();
        $translate = $this->di->get('translation');

        //@TODO Implementar validações
        return $this->validate($validator);
    }

    /**
     * Initialize method for model.
     */
    public function initialize()
    {
        $this->belongsTo('patient_form_id', 'PatientForm', 'id', array('alias' => 'PatientForm'));
        $this->belongsTo('drug_id', 'Drug', 'id', array('alias' => 'Drug'));
    }

    /**
     * Returns table name mapped in the model.
     *
     * @return string
     */
    public function getSource()
    {
        return 'patient_drug';
    }

}
