<?php

use Phalcon\Validation\Validator\PresenceOf as PresenceOf;
use Phalcon\Validation\Validator\Between as Between;
use Phalcon\Validation\Validator\Numericality as Numericality;
use \Phalcon\Mvc\Model\Message as Message;
use Phalcon\Validation;

class PatientHabits extends ModelBase
{
    /**
     * Handle nested results
     */
    public static $Relations = [
        'PatientForm' => 'patient_form_id'
    ];

    /**
     * Clear cache for related models
     */
    // public static $clearCache = [
    //  'ModelRelated'
    // ];

    public static $forbiddenFields = [
        'patient_form_id'
    ];

    public $patient_form_id;

    public $smoke;

    public $smoke_time;

    public $smoke_amount;

    public $alcohol;

    public $alcohol_time;

    public $in_natura;

    public $min_processed;

    public $processed;

    public $ultra_processed;

    public $moderated_sports_week;

    public $moderated_sports_time;

    public $high_sports_week;

    public $high_sports_time;

    public $physical_activity;

    public function validation(){

        $validator = new Validation();
        $translate = $this->di->get('translation');

        $validator->add(
                ['smoke','alcohol'],
                new Between(
                    array(
                        'minimum' => 1,
                        'maximum' => 3,
                        'message' => [
                            'smoke' => 'Tabagismo : ' . $translate->t('validator.outofbounds'),
                            'alcohol' => 'Alcoolismo : ' . $translate->t('validator.outofbounds'),
                        ]
                    )
                )
            );

        $validator->add(
                'physical_activity',
                new Between(
                    array(
                        'minimum' => 1,
                        'maximum' => 2,
                        'message' => 'Atividade Física : ' . $translate->t('validator.outofbounds'),
                        
                    )
                )
            );


        //Verificar se posso ter um add multiplo com 1 mensagem
        $validator->add(
                ['smoke_amount','in_natura','min_processed','processed','ultra_processed'],
                new Numericality(
                    array(
                        'message' => $translate->t('validator.number')
                    )
                )
            );
        return $this->validate($validator);
    }

    /**
     * Initialize method for model.
     */
    public function initialize()
    {
        $this->belongsTo('patient_form_id', 'PatientForm', 'id', array('alias' => 'PatientForm'));
    }

    /**
     * Returns table name mapped in the model.
     *
     * @return string
     */
    public function getSource()
    {
        return 'patient_habits';
    }

}
