<?php

use Phalcon\Validation\Validator\PresenceOf as PresenceOf;
use Phalcon\Validation\Validator\Between as Between;
use \Phalcon\Mvc\Model\Message as Message;
use Phalcon\Validation;

class PatientQuality extends ModelBase
{
    /**
     * Handle nested results
     */
    public static $Relations = [
        'PatientForm' => 'patient_form_id'
    ];

    /**
     * Clear cache for related models
     */
    // public static $clearCache = [
    //  'ModelRelated'
    // ];

    public static $forbiddenFields = [
        'patient_form_id'
    ];

    public $patient_form_id;

    public $question1;

    public $question2;

    public $question3;

    public $question4;

    public $question5;

    public $question6;

    public $question7;

    public $question8;

    public $question9;

    public $question10;

    public $question11;

    public $question12;

    public $question13;

    public $question14;

    public $question15;

    public $question16;

    public $question17;

    public function validation(){

        $validator = new Validation();
        $translate = $this->di->get('translation');

        for ($i = 1; $i <= 17; $i++ ){
            $validator->add(
                'question'.$i,
                new Between(
                    array(
                        'minimum' => 0,
                        'maximum' => 3,
                        'message' => 'Questão '.$i.' : '.$translate->t('validator.outofbounds')
                    )
                )
            );
        }

        return $this->validate($validator);
    }

    /**
     * Initialize method for model.
     */
    public function initialize()
    {
        $this->belongsTo('patient_form_id', 'PatientForm', 'id', array('alias' => 'PatientForm'));
    }

    /**
     * Returns table name mapped in the model.
     *
     * @return string
     */
    public function getSource()
    {
        return 'patient_quality';
    }

}
