<?php


class Auth {

	public static function login($user = null,$pwd = null,$app){
		if ($user && $pwd){
			$login = User::findFirst(array(
						"conditions" => "email=?1 AND password=?2 AND valid=1",
						"bind" => array(1=>$user,2=>sha1($pwd))
			),false);
			if ($login){
				$app->session->set('id',$login->id);
				$app->session->set('level',1);
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	public static function apiKey($key,$app){
		$apikey = Apikey::findFirst(array(
                                    "private_key = ?1 and valid='1'",
                                    "bind" => array( 1 => hash_hmac('md5',$key,$app->config->keychain->apikey) )
        ));
        if ($apikey){
        	if ($apikey->generate_date + $app->config->api->keytimeout >= time()){
        		$app->session->set('id',$apikey->user_id);
				$app->session->set('level',1);
        	} else {

        		$newApikey = new Apikey();
				$newApikey->public_key = base64_encode(time().'X'.$apikey->user_id);
				$newApikey->private_key = hash_hmac('md5',$newApikey->public_key,$app->config->keychain->apikey);
				$newApikey->user_id = $apikey->user_id;
				$newApikey->device = $app->request->getUserAgent();
				$newApikey->save();
				$apikey->delete();
        		$app->response->setHeader("Apikey",$newApikey->public_key);
        		$app->session->set('id',$newApikey->user_id);
				$app->session->set('level',1);
        	}
        	return true;
        } else {
        	return false;
        }
		return false;
	}

}


?>
