<?php

class Math {
	
	private $dados;

	private $total_dados;

	public function __construct($dados = array()){
		$this->dados = $dados; 
		$this->total_dados = count($this->dados);
	}

	public function media(){
		return $this->dados ? array_sum($this->dados)/$this->total_dados : 0;
	}

	public function mediana(){
		if($this->dados){
	        sort($this->dados);
	        $mid = floor(($this->total_dados-1)/2);
	        return ($this->dados[$mid]+$this->dados[$mid+1-$this->total_dados%2])/2;
	    }
	    return 0;
	}

	public function max(){
		return max($this->dados);
	}

	public function min(){
		return min($this->dados);
	}

	public function desvioPadrao(){
		$mean = array_sum($this->dados) / $this->total_dados;
		$carry = 0.0;
		foreach ($this->dados as $val){
			$d = ((double) $val) - $mean;
			$carry += $d * $d;
		}
		return sqrt($carry / $this->total_dados);
	}

	public function frequencia(){
		$r = array_count_values($this->dados);
		ksort($r);
		return $r;
	}

	public function porcentagem(){
		$array = array();
		$valores = array_count_values($this->dados);
		$soma = array_sum($valores);
		foreach ($valores as $key => $valor){
			$array[$key] = ($valor/$soma) * 100;
		}
		return $array;
	}

}