var app = angular.module('caixinhadecuidados', [
    'ionic',
    'ionic-material',
    'ionMdInput',
    'ui.rCalendar',
    'toastr',
    'satellizer',
    'ngStorage',
    'ui.utils.masks',
    'ngMask',
    'ngCordova',
    'ngResource',
    'displayMask',
    'ion-floating-menu',
    'ion-autocomplete'
])
/*Config do toastr*/
.config(function(toastrConfig) {
  angular.extend(toastrConfig, {
    containerId: 'toast-container',
    positionClass: 'toast-bottom-center',
    target: 'body'
  });
})
/*Constante da url da api*/
.constant("_C",{
  urlApi :"http://caixinhadecuidados.us-east-1.elasticbeanstalk.com/",
  // urlApi :"http://192.241.198.6/api/",
  sexo : [
    {id:'', text:'-selecione-'},
    {id:'1',text:"Feminino"},
    {id:'2',text:"Masculino"}
  ],
  estadoCivil : [
    {id:'', text:'-selecione-'},
    {id:'1',text:"Solteiro(a)"},
    {id:'2',text:"Casado(a) ou União consensual"},
    {id:'3',text:"Viúvo(a)"},
    {id:'4',text:"Separado(a) ou Divorciado(a)"}
  ],
  numeroFilhos : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"0"},
    {id:'2', text:"1 a 3"},
    {id:'3', text:"Mais de 3"}
  ],
  escolaridade : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"<9 anos"},
    {id:'2', text:"9 a 12 anos"},
    {id:'3', text:"13 a 16 anos"},
    {id:'4', text:">16 anos"}
  ],
  ocupacao : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Ativo(a)"},
    {id:'2', text:"Aposentado(a)"},
    {id:'3', text:"Exerce atividade do lar"},
    {id:'4', text:"Desempregado"},
    {id:'5', text:"Auxílio doença"}
  ],
  tabagismo : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Sim"},
    {id:'2', text:"Não"},
    {id:'3', text:"Ex-tabagista"}
  ],
  alcoolismo : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Não ingere"},
    {id:'2', text:"Ingesta moderada"},
    {id:'3', text:"Ingesta mais que moderada"}
  ],
  atividadeFisica : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Pratica (150 minutos/semana de atividades moderadas ou 75 minutos/semana de atividades vigorosas ou mista (moderada/vigorosa)"},
    {id:'2', text:"Não pratica (menos de 150 minutos/semana de atividades moderadas e/ou menos de 75 minutos/semana de atividades vigorosas ou mista (moderada/vigorosa)"}
  ],
  imc : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Baixo Peso (< 18,5) ", ini:0,fim:18.5},
    {id:'2', text:"Peso Saudável (18,5 a 24,9) ", ini:18.5, fim: 25},
    {id:'3', text:"Sobrepeso (25,0 a 29,9) ", ini:25, fim:30},
    {id:'4', text:"Obesidade (>= 30)", ini:30,fim:999999}
  ],
  circunferenciaAbdominal: {
    homem : [
        {id:'', text:'-selecione-'},
        {id:'1', text:"Normal (até 102cm)", ini:0,fim:102},
        {id:'2', text:"Acima (>= 102cm)", ini:102, fim:999999}
    ],
    mulher: [
        {id:'', text:'-selecione-'},
        {id:'1', text:"Normal (até 88cm)", ini:0,fim:88},
        {id:'2', text:"Acima (>= 88cm)", ini:88,fim:999999}
    ]
  },
  pressao : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Normal (<=120/<=90 mmHg)"},
    {id:'3', text:"Pré-hipertensão (121-139/81-89 mmHg)"},
    {id:'4', text:"Estágio 1 (140-159/90-99 mmHg)"},
    {id:'5', text:"Estágio 2 (160-179/100-109 mmHg)"},
    {id:'6', text:"Estágio 3 (>=180/>=110 mmHg)"},
    {id:'7', text:"HA Isolada (>=140 <90 mmHg)"}
  ],
  indiceTornozeloBraquial : [
    {id:'', text:'-selecione-'},
    {id:'1', text:"Normal (acima de 0,90)",ini:0.91,fim:999999},
    {id:'2', text:"Obstrução leve (0,71 - 0,90)",ini:0.71,fim:0.91},
    {id:'3', text:"Obstrução (0,41 - 0,70)", ini:0.41,fim:0.71},
    {id:'4', text:"Obstrução grave (0,00-0,40)", ini:0,fim:0.41}
  ],
  posologia : [
    {id:'1',text:'Manhã'},
    {id:'3',text:'Manhã, Tarde'},
    {id:'7',text:'Manhã, Tarde, Noite'},
    {id:'5',text:'Manhã, Noite'},
    {id:'2',text:'Tarde'},
    {id:'6',text:'Tarde, Noite'},
    {id:'4',text:'Noite'}
  ],
  tempoDiagnostico : [
    {id:'1',text:'<1 ano'},
    {id:'2',text:'1 a 5 anos'},
    {id:'3',text:'6 a 10 anos'},
    {id:'4',text:'> 10 anos'}
  ],
  numeroHospitalizacoes : [
    {id:'0',text:'Nenhuma'},
    {id:'1',text:'1'},
    {id:'2',text:'2 a 3'},
    {id:'3',text:'> 3'}
  ],
  numeroMedicacoesUso : [
    {id:'1',text:'Não usa'},
    {id:'2',text:'1'},
    {id:'3',text:'2 a 3'},
    {id:'4',text:'4 a 5'},
    {id:'5',text:'> 5'}
  ],
  qualidade : [
    {id:'',text:'-selecione-'},
    {id:0,text:'Não, absolutamente'},
    {id:1,text:'Sim, um pouco'},
    {id:2,text:'Sim, bastante'},
    {id:3,text:'Sim, muito'}
  ],
  depressao: [ 
    {id:'',text:'-selecione-'},
    {id:'1',text:'Sim'},
    {id:'2',text:'Não'}
  ],
  risco: [ 
    {id:'',text:'-selecione-'},
    {id:'1',text:'Baixo'},
    {id:'2',text:'Moderado'},
    {id:'3',text:'Alto'},
    {id:'4',text:'Muito Alto'}
  ],
  grupo: [ 
    {id:'',text:'-selecione-'},
    {id:'1',text:'Intervenção'},
    {id:'2',text:'Controle'}
  ]

  /*filesUrl : function(){
    if(ionic.Platform.isAndroid()){
      return cordova.file.externalApplicationStorageDirectory ;
    }
    else{
      return cordova.file.documentsDirectory ;
    };

  }*/
})
.factory('httpRequestInterceptor', function ($q, $location,$localStorage,$injector,$timeout,$rootScope) {
    return {
        'request': function(request) {
            if(!request.ignoreLoading){
              $rootScope.$broadcast('loading:show');
            }
            if($localStorage.apikey){
                request.headers["apikey"] = $localStorage.apikey;
            };
            return request;
         },
        'response': function(response) {
            if(response.config){
              if(!response.config.ignoreLoading){
                $rootScope.$broadcast('loading:hide');
              }
            }
            else{
              $rootScope.$broadcast('loading:hide');
            }
            if(response.headers("apikey")){
                $localStorage.apikey = response.headers("apikey");
            };
            return response;
         },
        'responseError': function(rejection) {
            if(rejection.config){
              if(!rejection.config.ignoreLoading){
                $rootScope.$broadcast('loading:hide');
              }
            }
            else{
              $rootScope.$broadcast('loading:hide');
            }
            if(rejection.headers("apikey")){
                $localStorage.apikey = rejection.headers("apikey");
            };
            //do something on error
            if(rejection.status === 401){
                if(rejection.config.headers.apikey!==$localStorage.apikey && (rejection.config.headers.apikey && $localStorage.apikey)){
                    $timeout(function(){
                        var $http = $injector.get('$http');
                        return $http(rejection.config);   
                    },500);
                }
                else{
                    // console.log("desclogou");
                    $localStorage.$reset();
                    $location.path('/app/login');   
                }
            }
            if(rejection.status === 403){
                $localStorage.$reset();
                $location.path('/app/login');   
            }
            return $q.reject(rejection);
         }
     };
})
.config(['$httpProvider',function($httpProvider){
  $httpProvider.interceptors.push('httpRequestInterceptor');
}])
.run(function($ionicPlatform,$rootScope,$ionicLoading,$ionicPopup,$ionicHistory,$timeout,$cordovaStatusbar) {
    /*Configurações para loading na tela*/
    var loadingCount = 0;
    $rootScope.$on('loading:show', function() {
        loadingCount++;
        $ionicLoading.show({
            animation: 'fade-in',
            template: 'Carregando...'
        });
    });
    $rootScope.$on('loading:hide', function() {
        loadingCount--;
        if(loadingCount<1){
            loadingCount=0;
            $ionicLoading.hide();
        }
    });
    $rootScope.$on('$stateChangeStart', function () {
        $rootScope.$broadcast('loading:show');
    });
    $rootScope.$on('$stateChangeSuccess', function () {
        $timeout(function(){
            $rootScope.$broadcast('loading:hide');
        },500);
    });
    $ionicPlatform.ready(function() {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        if (window.StatusBar) {
          // org.apache.cordova.statusbar required
          // StatusBar.styleDefault();
          $cordovaStatusbar.overlaysWebView(true);
          $cordovaStatusbar.styleHex("#0F4659");
          $cordovaStatusbar.show();
          // $cordovaStatusbar.styleBlackOpaque();
        }

    });
    /*Confirmar ao sair*/
    $ionicPlatform.registerBackButtonAction(function(e) {
        e.preventDefault();
        function showConfirm() {
            var confirmPopup = $ionicPopup.confirm({
                title: '<strong>Sair da Caixinha de Cuidados?</strong>',
                template: 'Deseja fechar o aplicativo?'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    ionic.Platform.exitApp();
                } else {
                // Don't close
                }
            });
        }
        // Is there a page to go back to?
        if ($ionicHistory.backView()) {
        // Go back in history
            $ionicHistory.goBack();
        } else {
        // This is the last page: Show confirmation popup
            showConfirm();
        }
        return false;
    }, 101);

    // triggered every time notification received
    $rootScope.$on('$cordovaPushV5:notificationReceived', function(event, data){

    });

    // triggered every time error occurs
    $rootScope.$on('$cordovaPushV5:errorOcurred', function(event, e){

    });
});
