'use strict';
app
.directive('infoModal', function() {
  return {
    restrict: 'E',
    transclude: true,
    scope: {
      title: '@',
      info: '@'
    },
    controller: function InfoModalController($scope,$ionicModal,ionicMaterialInk) {
      $scope.modal = $ionicModal.fromTemplate(''
        +'<ion-modal-view>'
        +'<ion-header-bar class="dark-bg">'
        +'<h1 class="title">{{title}}</h1><div class="button button-clear" ng-click="closeModal()"><i class="fa fa-times"></i></div>'
        +'</ion-header-bar>'
        +'<ion-content class="padding">{{info}}</ion-content>'
        +'<ion-footer-bar class="bar bar-positive "><button class="button button-full button-positive ink" ng-click="closeModal()">Fechar</button></ion-footer-bar>'
        +'</ion-modal-view>', {
        scope: $scope,
        animation: 'slide-in-up'
      });
      // Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      $scope.openModal  = function(){
        $scope.modal.show();
        ionicMaterialInk.displayEffect();
      }
    },
    template : '<i class=" col col-10 mt-25 fa fa-question-circle fa-2x" ng-click="openModal()"></i>'
  };
});