'use strict';
/**
 * @ngdoc overview
 * @name app
 * Automatic app 
 */
var app = angular
  .module('app', [
    'ngAnimate',
    'ngCookies',
    'ngResource',
    'ngSanitize',
    'picardy.fontawesome',
    'ui.bootstrap', 
    'ui.router',
    'ui.utils',
    'angular-loading-bar',
    'angularMoment',
    'toastr',
    'ui.utils.masks',
    'ngMask',
    'ngMaterial',
    'pascalprecht.translate',
    'angular.morris',
    'chart.js',
    'ngStorage',
    'ngMdIcons'
  ])
  .value('urlApi','http://caixinhadecuidados.us-east-1.elasticbeanstalk.com/')
  /*Constante da url da api*/
  .constant("_C",{
  urlApi :"http://caixinhadecuidados.us-east-1.elasticbeanstalk.com/",
    // urlApi :"http://192.241.198.6/api/",
    sexo : [
      {id:'', text:'-selecione-'},
      {id:'1',text:"Feminino"},
      {id:'2',text:"Masculino"}
    ],
    estadoCivil : [
      {id:'', text:'-selecione-'},
      {id:'1',text:"Solteiro(a)"},
      {id:'2',text:"Casado(a) ou União consensual"},
      {id:'3',text:"Viúvo(a)"},
      {id:'4',text:"Separado(a) ou Divorciado(a)"}
    ],
    numeroFilhos : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"0"},
      {id:'2', text:"1 a 3"},
      {id:'3', text:"Mais de 3"}
    ],
    escolaridade : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"<9 anos"},
      {id:'2', text:"9 a 12 anos"},
      {id:'3', text:"13 a 16 anos"},
      {id:'4', text:">16 anos"}
    ],
    ocupacao : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Ativo(a)"},
      {id:'2', text:"Aposentado(a)"},
      {id:'3', text:"Exerce atividade do lar"},
      {id:'4', text:"Desempregado"},
      {id:'5', text:"Auxílio doença"}
    ],
    tabagismo : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Sim"},
      {id:'2', text:"Não"},
      {id:'3', text:"Ex-tabagista"}
    ],
    alcoolismo : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Não ingere"},
      {id:'2', text:"Ingesta moderada"},
      {id:'3', text:"Ingesta mais que moderada"}
    ],
    atividadeFisica : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Pratica (150 minutos/semana de atividades moderadas ou 75 minutos/semana de atividades vigorosas ou mista (moderada/vigorosa)"},
      {id:'2', text:"Não pratica (menos de 150 minutos/semana de atividades moderadas e/ou menos de 75 minutos/semana de atividades vigorosas ou mista (moderada/vigorosa)"}
    ],
    imc : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Baixo Peso (< 18,5) ", ini:0,fim:18.5},
      {id:'2', text:"Peso Saudável (18,5 a 24,9) ", ini:18.5, fim: 25},
      {id:'3', text:"Sobrepeso (25,0 a 29,9) ", ini:25, fim:30},
      {id:'4', text:"Obesidade (>= 30)", ini:30,fim:999999}
    ],
    circunferenciaAbdominal: {
      homem : [
          {id:'', text:'-selecione-'},
          {id:'1', text:"Normal (até 102cm)", ini:0,fim:102},
          {id:'2', text:"Acima (>= 102cm)", ini:102, fim:999999}
      ],
      mulher: [
          {id:'', text:'-selecione-'},
          {id:'1', text:"Normal (até 88cm)", ini:0,fim:88},
          {id:'2', text:"Acima (>= 88cm)", ini:88,fim:999999}
      ]
    },
    pressao : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Normal (<=120/<=90 mmHg)"},
      {id:'3', text:"Pré-hipertensão (121-139/81-89 mmHg)"},
      {id:'4', text:"Estágio 1 (140-159/90-99 mmHg)"},
      {id:'5', text:"Estágio 2 (160-179/100-109 mmHg)"},
      {id:'6', text:"Estágio 3 (>=180/>=110 mmHg)"},
      {id:'7', text:"HA Isolada (>=140 <90 mmHg)"}
    ],
    indiceTornozeloBraquial : [
      {id:'', text:'-selecione-'},
      {id:'1', text:"Normal (acima de 0,90)",ini:0.91,fim:999999},
      {id:'2', text:"Obstrução leve (0,71 - 0,90)",ini:0.71,fim:0.91},
      {id:'3', text:"Obstrução (0,41 - 0,70)", ini:0.41,fim:0.71},
      {id:'4', text:"Obstrução grave (0,00-0,40)", ini:0,fim:0.41}
    ],
    posologia : [
      {id:'1',text:'Manhã'},
      {id:'3',text:'Manhã, Tarde'},
      {id:'7',text:'Manhã, Tarde, Noite'},
      {id:'5',text:'Manhã, Noite'},
      {id:'2',text:'Tarde'},
      {id:'6',text:'Tarde, Noite'},
      {id:'4',text:'Noite'}
    ],
    tempoDiagnostico : [
      {id:'1',text:'<1 ano'},
      {id:'2',text:'1 a 5 anos'},
      {id:'3',text:'6 a 10 anos'},
      {id:'4',text:'> 10 anos'}
    ],
    numeroHospitalizacoes : [
      {id:'0',text:'Nenhuma'},
      {id:'1',text:'1'},
      {id:'2',text:'2 a 3'},
      {id:'3',text:'> 3'}
    ],
    numeroMedicacoesUso : [
      {id:'1',text:'Não usa'},
      {id:'2',text:'1'},
      {id:'3',text:'2 a 3'},
      {id:'4',text:'4 a 5'},
      {id:'5',text:'> 5'}
    ],
    qualidade : [
      {id:'',text:'-selecione-'},
      {id:'0',text:'Não, absolutamente'},
      {id:'1',text:'Sim, um pouco'},
      {id:'2',text:'Sim, bastante'},
      {id:'3',text:'Sim, muito'}
    ],
    depressao: [ 
      {id:'',text:'-selecione-'},
      {id:'1',text:'Sim'},
      {id:'2',text:'Não'}
    ],
    risco: [ 
      {id:'',text:'-selecione-'},
      {id:'1',text:'Baixo'},
      {id:'2',text:'Moderado'},
      {id:'3',text:'Alto'},
      {id:'4',text:'Muito Alto'}
    ],
    grupo: [ 
      {id:'',text:'-selecione-'},
      {id:'1',text:'Intervenção'},
      {id:'2',text:'Controle'}
    ]


    /*filesUrl : function(){
      if(ionic.Platform.isAndroid()){
        return cordova.file.externalApplicationStorageDirectory ;
      }
      else{
        return cordova.file.documentsDirectory ;
      };

    }*/
  })
  .factory('httpRequestInterceptor', function ($q, $location,$localStorage,$injector,$timeout) {
    return {
        'request': function(request) {
            if($localStorage.apikey){
                request.headers["apikey"] = $localStorage.apikey;
            };
            return request;
         },
        'response': function(response) {
            if(response.headers("apikey")){
                $localStorage.apikey = response.headers("apikey");
            };
            return response;
         },
        'responseError': function(rejection) {
            if(rejection.headers("apikey")){
                $localStorage.apikey = rejection.headers("apikey");
            };
            //do something on error
            if(rejection.status === 401){
                console.log(rejection.config.headers.apikey);
                console.log($localStorage.apikey);
                if(rejection.config.headers.apikey!==$localStorage.apikey && (rejection.config.headers.apikey && $localStorage.apikey)){
                    $timeout(function(){
                        var $http = $injector.get('$http');
                        return $http(rejection.config);   
                    },500);
                }
                else{
                    // console.log("desclogou");
                    $localStorage.$reset();
                    $location.path('/login');   
                }
            }
            if(rejection.status === 403){
                $localStorage.$reset();
                $location.path('/login');   
            }
            return $q.reject(rejection);
         }
     };
  })
  .config(function($mdDateLocaleProvider,moment) {
    $mdDateLocaleProvider.formatDate = function(date) {
      if(date){
       return moment(date).format('DD/MM/YYYY');
      }
      return "";
    };
    $mdDateLocaleProvider.parseDate = function(date) {
      var m = moment(date, 'DD/MM/YYYY', true);
      return m.isValid() ? m.toDate() : new Date(NaN);
    };
  })
  .config(function ($provide) {
      $provide.decorator('dateFilter', function ($delegate) {
          return function () {
              // Check if the date format argument is not provided
              if (!arguments[1]) { 
                  arguments[1] = 'dd MMMM @ HH:mm:ss';
              }
              if(arguments[0]){
                if(arguments[0]<9999999999999){ // check if unix timestamp
                  arguments[0] = arguments[0]*1000;
                }
              }
              var value = $delegate.apply(null, arguments);
              return value;
          };
      })
  })
  .config(['$translateProvider', function($translateProvider) {
      $translateProvider.useStaticFilesLoader({
        prefix: 'languages/',
        suffix: '.json'
      });
      $translateProvider.useLocalStorage();
      $translateProvider.preferredLanguage('pt_br');
      $translateProvider.useSanitizeValueStrategy(null);
  }])
.config(function ($mdThemingProvider) {
    var customPrimary = {
        '50': '#43b7de',
        '100': '#2dafdb',
        '200': '#23a0cb',
        '300': '#208fb5',
        '400': '#1c7ea0',
        '500': '#186D8A',
        '600': '#145c74',
        '700': '#104b5f',
        '800': '#0d3a49',
        '900': '#092833',
        'A100': '#59bfe2',
        'A200': '#6fc8e6',
        'A400': '#84d0ea',
        'A700': '#05171d',
        'contrastDefaultColor': 'light'
    };
    $mdThemingProvider
        .definePalette('customPrimary', 
                        customPrimary);

    var customAccent = {
        '50': '#000a08',
        '100': '#00231d',
        '200': '#003d31',
        '300': '#005646',
        '400': '#00705a',
        '500': '#00896f',
        '600': '#00bc97',
        '700': '#00d6ac',
        '800': '#00efc0',
        '900': '#0affcf',
        'A100': '#00bc97',
        'A200': '#00a383',
        'A400': '#00896f',
        'A700': '#23ffd4',
        'contrastDefaultColor': 'light'
    };
    $mdThemingProvider
        .definePalette('customAccent', 
                        customAccent);

    var customWarn = {
        '50': '#ffb380',
        '100': '#ffa466',
        '200': '#ff954d',
        '300': '#ff8533',
        '400': '#ff761a',
        '500': '#ff6700',
        '600': '#e65d00',
        '700': '#cc5200',
        '800': '#b34800',
        '900': '#993e00',
        'A100': '#ffc299',
        'A200': '#ffd1b3',
        'A400': '#ffe1cc',
        'A700': '#803400',
        'contrastDefaultColor': 'light'
    };
    $mdThemingProvider
        .definePalette('customWarn', 
                        customWarn);

    var customBackground = {
        '50': '#fdfdfd',
        '100': '#f0f0f0',
        '200': '#e3e3e3',
        '300': '#d6d6d6',
        '400': '#cacaca',
        '500': '#BDBDBD',
        '600': '#b0b0b0',
        '700': '#a3a3a3',
        '800': '#979797',
        '900': '#8a8a8a',
        'A100': '#ffffff',
        'A200': '#ffffff',
        'A400': '#ffffff',
        'A700': '#7d7d7d',
        'contrastDefaultColor': 'light'
    };
    $mdThemingProvider
        .definePalette('customBackground', 
                        customBackground);

   $mdThemingProvider.theme('default')
       .primaryPalette('customPrimary')
       .accentPalette('customAccent')
       .warnPalette('customWarn')
       .backgroundPalette('customBackground')
})
  .config(['$httpProvider',function($httpProvider){
    $httpProvider.interceptors.push('httpRequestInterceptor');
  }])
  .run(function($rootScope, $state, $stateParams, $location, $cookies, $http,amMoment) {
      if($cookies.get("BasicAuth")!==""){
          $http.defaults.headers.common.Authorization = $cookies.get("BasicAuth");
      }
      amMoment.changeLocale("pt-br");
      $rootScope.$on('$locationChangeStart', function (event, next, current) {
        /*DESATIVADO O SISTEMA DE LOGIN PARA CHEGAR SE O USUÁRIO ESTÁ LOGADO*/
        /*
          if ($location.path() !== '/core/login' && !$cookies.apiKey && $location.path() !== '/core/register' && $location.path() !== '/core/signup' && $location.path() !== '/core/lock_screen' && $location.path() !== '/core/forgotpass') {
              $state.transitionTo('core.login');
              //$location.path('/core/login');
              $cookies.apiKey = '';
              $cookies.username = '';
          }
          */
      });

  })
  .config(['$stateProvider','$urlRouterProvider',function ($stateProvider,$urlRouterProvider) {

    $urlRouterProvider.otherwise('/login');
    $stateProvider
      .state('dashboard', {
        url:'/dashboard',
        templateUrl: 'views/tmpl/dashboard/main.html'
    })
      .state('dashboard.home_user',{
        url:'/home_user',
        controller: 'MainCtrl',
        templateUrl:'views/tmpl/dashboard/home_user.html'
      })
      .state('dashboard.home',{
        url:'/home',
        controller: 'MainCtrl',
        templateUrl:'views/tmpl/dashboard/home.html'
      })
      .state('dashboard.profile',{
        url:'/profile',
        controller: 'ProfileCtrl',
        templateUrl:'views/tmpl/pages/profile.html'
      })
    .state('admin', {
        url:'/admin',
        templateUrl: 'views/tmpl/dashboard/main.html'
    })
      .state('admin.users',{
        url:'/user',
        controller: 'AdminUserCtrl',
        templateUrl:'views/tmpl/admin/user.html'
      })
      .state('admin.patient',{
        url:'/patient',
        controller: 'AdminPatientCtrl',
        templateUrl:'views/tmpl/admin/patient.html'
      })
      .state('admin.research',{
        url:'/research',
        controller: 'AdminResearchCtrl',
        templateUrl:'views/tmpl/admin/research.html'
      })
      .state('admin.research-view',{
        url:'/view/:id',
        controller: 'AdminResearchCtrl',
        templateUrl:'views/tmpl/admin/research-view.html'
      })
      .state('admin.drug',{
        url:'/drug',
        controller: 'AdminDrugCtrl',
        templateUrl:'views/tmpl/admin/drug.html'
      })
      .state('login',{
        templateUrl:'views/tmpl/pages/login.html',
        url:'/login',
        controller : "LoginCtrl"
    })
      .state('recovery',{
        templateUrl:'views/tmpl/pages/recovery.html',
        url:'/recovery',
        controller : "RecoveryCtrl"
    })
    .state('recoveryChangePassword',{
      templateUrl:'views/tmpl/pages/recovery.html',
      url:'/password_recovery/:id/:token',
      controller : "RecoveryChangePasswordCtrl"
    })
    .state('validate',{
      templateUrl:'views/tmpl/pages/validate.html',
      url:'/validate',
      controller : "ValidateCtrl"
    })
  }]);

    
