'use strict';
app
	.controller('AdminDrugCtrl', function($scope,DrugResource,$localStorage,$mdDialog) {
		$scope.drugs = DrugResource.query();

		$scope.openNewDrug = function(ev){
		    $mdDialog.show({
		      controller: 'AdminNewDrugCtrl',
		      templateUrl: 'views/tmpl/admin/newDrug.html',
		      parent: angular.element(document.body),
		      targetEvent: ev,
		      clickOutsideToClose:true,
		      fullscreen: true, // Only for -xs, -sm breakpoints.
	        resolve : {
	          Drug :  function(){ return false }
	        }
		    })
		    .then(function(drug) {
	      	if(drug){
		      	if(!$scope.drugs.length>0){
		      		$scope.drugs = [];
		      	}
	      		$scope.drugs.unshift(drug);
	      	}
		    });
		}

		$scope.edit = function(ev,u){
		    $mdDialog.show({
		      controller: 'AdminNewDrugCtrl',
		      templateUrl: 'views/tmpl/admin/newDrug.html',
		      parent: angular.element(document.body),
		      targetEvent: ev,
		      clickOutsideToClose:true,
		      fullscreen: true, // Only for -xs, -sm breakpoints.
	        resolve : {
	          Drug :  function(){ return u }
	        }
		    })
		    .then(function(drug) {
	      	if(drug){
	      		u = drug;
	      	}
		    });
		}

		$scope.remove = function(u){
	      /*TROCAR AQUI EM BAIXO TUDO PRO TRANSLATE!!!!*/
	      swal({
	        title: 'Deseja remover o medicamento '+u.name+'?',
	        text: "Essa ação é irreversível.. Para confirmar digite no campo abaixo a palavra CONFIRMAR",
	        type: 'question',
	        input: 'text',
	        showCancelButton: true,
	        confirmButtonColor: '#3085d6',
	        cancelButtonColor: '#d33',
	        confirmButtonText: 'Sim!',
	        cancelButtonText: 'Não, cancelar!',
	        showLoaderOnConfirm : true,
	        preConfirm: function(deleteInput){
	            return new Promise(function(resolve, reject) {
	              if (deleteInput !== 'CONFIRMAR') {
	                reject('Preencha no campo acima a palavra CONFIRMAR');
	              } else {
	                u.$delete({id:u.id},function(){
	                  swal({
	                    title : "Removido medicamento com sucesso",
	                    type : "success"
	                  });
	                },
	                function(){
	                  swal({
	                    title : "Erro ao remover medicamento",
	                    type : "error"
	                  })
	                });
	              }
	            });
	          }
	        })

		}


  })
.controller('AdminNewDrugCtrl', function($scope,DrugResource,$localStorage,$mdDialog,toastr,Drug,$timeout,$translate,moment) {
		if(Drug){
			$scope.drug = Drug;
		}
		else{
			$scope.drug =  new DrugResource();
			$scope.drug.name = "";
			$scope.drug.type = "";
			$scope.drug.unit_type = "";
			$scope.drug.quantity = 0;

		}
	    $scope.valid = function(){
	    	var vl = 1 ;
	      $timeout(function(){
	        if(vl){$scope.save()}}, 100);
	    }

		$scope.save = function(){
			if(angular.isUndefined($scope.drug.id)){
				$scope.drug.$save(function(){
					toastr.success("Medicamento criado com sucesso",{timeOut:4000});
					$mdDialog.hide($scope.drug);
				},
				function(r){
					angular.forEach(r.data.error,function(v){
						toastr.error(v,{timeOut:4000});
					});
				})
			}
			else{
				$scope.drug.$update({id:$scope.drug.id},function(){
					toastr.success("Medicamento atualizado com sucesso",{timeOut:4000});
					$mdDialog.hide($scope.drug);
				},
				function(r){
					angular.forEach(r.data.error,function(v){
						toastr.error(v,{timeOut:4000});
					});
				})
			}
		}

		$scope.close = function(){
			$mdDialog.hide();
		}

  });;
