'use strict';
app
	.controller('AdminNewPatientCtrl', function($scope,PatientResource,$localStorage,$mdDialog,toastr,Patient,$timeout,$translate,moment,_C,QathasResource) {
		if(Patient){
			$scope.patient = Patient;
		}
		else{
			$scope.patient =  new PatientResource();
			$scope.patient.Person = {};
		    $scope.patient.Person.name = "";
		    $scope.patient.email = "";
		    $scope.patient.random_number = "";
		    $scope.patient.Person.born_date = "";
		    $scope.patient.Person.phone = "";
		    $scope.patient.Person.address = "";
		    $scope.patient.Person.neighborhood = "";
		    $scope.patient.Person.address_number = "";
		}
		$scope._C = _C;

		$scope.save = function(){
   			$scope.patient.Person.born_date = angular.isDate($scope.patient.Person.born_date)?Date.parse($scope.patient.Person.born_date)/1000:$scope.patient.Person.born_date;
			if(angular.isUndefined($scope.patient.id)){
				$scope.patient.$save(function(){
					toastr.success("Paciente criado com sucesso",{timeOut:4000});
					$mdDialog.hide($scope.patient);
				},
				function(r){
					angular.forEach(r.data.error,function(v){
						toastr.error(v,{timeOut:4000});
					});
				})
			}
			else{
				$scope.patient.$update({id:$scope.patient.id},function(){
					toastr.success("Paciente atualizado com sucesso",{timeOut:4000});
					$mdDialog.hide($scope.patient);
				},
				function(r){
					angular.forEach(r.data.error,function(v){
						toastr.error(v,{timeOut:4000});
					});
				})
			}
		}

		$scope.close = function(){
			$mdDialog.hide();
		}

		$scope.openQathas = function(){
			swal({
				width: 1024,
			  title: '<h3>Questionário de Adesão ao Tratamendo de Hipertensão Arterial Sistêmica</h3>',
        showLoaderOnConfirm : true,
			  html:	"<form class='text-left row formSweet' id='formAthas' >"+
				  			"<div class='col-xs-12'>"+
				  			"<p class='col-xs-12'>1. Alguma vez deixou de tomar sua medicação para HAS?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao0' id='questao0' autofocus/> sim, ao menos 1 vez ao dia</label>"+
								"<label class='small'><input type='radio' value='2' name='questao0' id='questao0'/> sim, ao menos 1 vez por semana</label>"+
								"<label class='small'><input type='radio' value='3' name='questao0' id='questao0'/> sim, ao menos 1 vez por mês</label>"+
								"<label class='small'><input type='radio' value='4' name='questao0' id='questao0'/> sim, ao menos 1 vez por ano</label>"+
								"<label class='small'><input type='radio' value='5' name='questao0' id='questao0'/> não</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>2. Alguma vez deixou de tomar sua medicação da HAS conforme a dose prescrita?</p>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<label class='small'><input type='radio' value='1' name='questao1' id='questao1'/> sim, ao menos 1 vez ao dia</label>"+
								"<label class='small'><input type='radio' value='2' name='questao1' id='questao1'/> sim, ao menos 1 vez por semana</label>"+
								"<label class='small'><input type='radio' value='3' name='questao1' id='questao1'/> sim, ao menos 1 vez por mês</label>"+
								"<label class='small'><input type='radio' value='4' name='questao1' id='questao1'/> ao menos 1 vez por ano ou nunca</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>3. Alguma vez deixou de tomar sua medicação da HAS nos horários estabelecidos?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao2' id='questao2'/> sim, ao menos 1 vez ao dia</label>"+
								"<label class='small'><input type='radio' value='2' name='questao2' id='questao2'/> sim, ao menos 1 vez por semana</label>"+
								"<label class='small'><input type='radio' value='3' name='questao2' id='questao2'/> sim, ao menos 1 vez por mês</label>"+
								"<label class='small'><input type='radio' value='4' name='questao2' id='questao2'/> ao menos 1 vez por ano ou nunca</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>4. Faz uso do medicamento para o tratamento da HAS somente quando apresenta algum sintoma?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao3' id='questao3'/> sim</label>"+
								"<label class='small'><input type='radio' value='2' name='questao3' id='questao3'/> não</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>5. Seguir o tratamento medicamentoso da HAS tornou-se uma rotina em sua vida?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao4' id='questao4'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao4' id='questao4'/> sim</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>6. Ao iniciar o tratamento para HAS, diminuiu o sal da alimentação?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao5' id='questao5'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao5' id='questao5'/> sim, reduzi à terça parte</label>"+
								"<label class='small'><input type='radio' value='3' name='questao5' id='questao5'/> sim, reduzi à metade</label>"+
								"<label class='small'><input type='radio' value='4' name='questao5' id='questao5'/> sim, como praticamente ensosso</label>"+
								"<label class='small'><input type='radio' value='5' name='questao5' id='questao5'/> sempre fiz uso de uma alimentação pobre em sal</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>7. Ao iniciar o tratamento para HAS, diminuiu a gordura da alimentação?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao6' id='questao6'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao6' id='questao6'/> sim, reduzi à terça parte</label>"+
								"<label class='small'><input type='radio' value='3' name='questao6' id='questao6'/> sim, reduzi à metade</label>"+
								"<label class='small'><input type='radio' value='4' name='questao6' id='questao6'/> sim, como praticamente sem gordura</label>"+
								"<label class='small'><input type='radio' value='5' name='questao6' id='questao6'/> sempre fiz uso de uma alimentação pobre em gordura</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>8. Ao iniciar o tratamento para HAS, passou a preferir o consumo de carnes brancas (aves, peixe)?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao7' id='questao7'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao7' id='questao7'/> sim, consumo carne branca até 03 vezes na semana</label>"+
								"<label class='small'><input type='radio' value='3' name='questao7' id='questao7'/> sim, consumo carne branca 04 ou mais vezes na semana</label>"+
								"<label class='small'><input type='radio' value='4' name='questao7' id='questao7'/> sempre consumi carnes brancas no mínimo 4 vezes por semana</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>9. Ao iniciar o tratamento para HAS, diminuiu o uso de doces e bebidas com açúcar?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao8' id='questao8'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao8' id='questao8'/> sim, reduzi à terça parte</label>"+
								"<label class='small'><input type='radio' value='3' name='questao8' id='questao8'/> sim, reduzi à metade</label>"+
								"<label class='small'><input type='radio' value='4' name='questao8' id='questao8'/> sim, como praticamente sem açúcar/doce</label>"+
								"<label class='small'><input type='radio' value='5' name='questao8' id='questao8'/> sempre fiz uso de uma alimentação pobre em doces e bebidas com açúcar</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>10. Com o inicio do tratamento para a HAS, passou a realizar 30 minutos de exercício físico (caminhada, natação, ciclismo)</p>"+
								"<label class='small'><input type='radio' value='1' name='questao9' id='questao9'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao9' id='questao9'/> sim, menos de 3 vezes por semana</label>"+
								"<label class='small'><input type='radio' value='3' name='questao9' id='questao9'/> sim, de 3 a 5 vezes por semana</label>"+
								"<label class='small'><input type='radio' value='4' name='questao9' id='questao9'/> sim, mais de 5 vezes por semana</label>"+
								"<label class='small'><input type='radio' value='5' name='questao9' id='questao9'/> sempre fiz exercício físico pelo menos 3 vezes por semana</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>11. Seguir o tratamento não medicamentoso da HAS tornou-se uma rotina em sua vida?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao10' id='questao10'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao10' id='questao10'/> sim</label>"+
								"</div>"+
				  			"<div class='col-xs-12'>"+
								"<p class='col-xs-12'>12. Comparece às consultas agendadas para o tratamento da HAS?</p>"+
								"<label class='small'><input type='radio' value='1' name='questao11' id='questao11'/> não</label>"+
								"<label class='small'><input type='radio' value='2' name='questao11' id='questao11'/> sim</label>"+
								"</div>"+
							"</form>",
			  preConfirm: function () {
			    return new Promise(function (resolve, reject) {
			    	var erro = false;
			    	var r = new QathasResource();
			    	for(var i=0;i<12;i++){
			    		if(!$("#questao"+i+":checked").val() || $("#questao"+i+":checked").val()==''){
			    			erro = true;
              	reject('Preencha a questão número '+(i+1));
            	}
            	else{
            		r["questao"+i] = $("#questao"+i+":checked").val();
            	}
			    	}
			    	if(!erro){
							r.$save(function(data){
								$scope.patient.qathas = r.coefficient;
			  				swal(
								  'Coeficiente calculado com sucesso!',
								  'Coeficiente: '+r.coefficient,
								  'success'
								 );
							},
							function(data){
								console.log("erro");
								console.log(data);
							})
			    	}
			    })
			  }
			}).then(function (result) {
			}).catch(swal.noop);
		}
  });
