'use strict';
app
	.controller('AdminPatientCtrl', function($scope,PatientResource,DumpResource,$localStorage,$mdDialog) {
		$scope.patients = PatientResource.query();

		$scope.dump = function(){
			swal({
	        title: 'Deseja extrair a base de conhecimento ?',
	        text: "Essa ação pode levar algum tempo até ser finalizada.",
	        type: 'question',
	        showCancelButton: true,
	        confirmButtonColor: '#3085d6',
	        cancelButtonColor: '#d33',
	        confirmButtonText: 'Sim!',
	        cancelButtonText: 'Não, cancelar!',
	        showLoaderOnConfirm : true,
	        preConfirm: function(){
	            return new Promise(function(resolve, reject) {
	            	$scope.dump = DumpResource.get(function(result){
	            		swal({
		                    title : "Base extraida com sucesso!",
		                    html: 'Download: <a href="'+result.url+'" target="_blank">Clique aqui</a>',
		                    type : "success"
		                  });
		        	},
		        	function(){
		        		swal({
	                    title : "Erro ao extrair base de conhecimento, por favor tente novamente.",
	                    type : "error"
	                  })
		        	});
	            });
	          }
	        })
		}

		$scope.openNewPatient = function(ev){
				$scope.patientTargetEvent = ev;
		    $mdDialog.show({
		      controller: 'AdminNewPatientCtrl',
		      templateUrl: 'views/tmpl/admin/newPatient.html',
		      parent: angular.element(document.body),
		      targetEvent: ev,
		      clickOutsideToClose:true,
		      fullscreen: true, // Only for -xs, -sm breakpoints.
	        resolve : {
	          Patient :  function(){ return false }
	        }
		    })
		    .then(function(patient) {
	      	if(patient){
		      	if(!$scope.patients.length>0){
		      		$scope.patients = [];
		      	}
	      		$scope.patients.unshift(patient);
	      	}
		    });
		}

		$scope.edit = function(ev,u){
		    $mdDialog.show({
		      controller: 'AdminNewPatientCtrl',
		      templateUrl: 'views/tmpl/admin/newPatient.html',
		      parent: angular.element(document.body),
		      targetEvent: ev,
		      clickOutsideToClose:true,
		      fullscreen: true, // Only for -xs, -sm breakpoints.
	        resolve : {
	          Patient :  function(){ return u }
	        }
		    })
		    .then(function(patient) {
	      	if(patient){
	      		u = patient;
	      	}
		    });
		}

		$scope.remove = function(u){
	      /*TROCAR AQUI EM BAIXO TUDO PRO TRANSLATE!!!!*/
	      swal({
	        title: 'Deseja remover o paciente '+u.Person.name+'?',
	        text: "Essa ação é irreversível.. O paciente perderá os acessos ao sistema!! Para confirmar digite no campo abaixo a palavra CONFIRMAR",
	        type: 'question',
	        input: 'text',
	        showCancelButton: true,
	        confirmButtonColor: '#3085d6',
	        cancelButtonColor: '#d33',
	        confirmButtonText: 'Sim!',
	        cancelButtonText: 'Não, cancelar!',
	        showLoaderOnConfirm : true,
	        preConfirm: function(deleteInput){
	            return new Promise(function(resolve, reject) {
	              if (deleteInput !== 'CONFIRMAR') {
	                reject('Preencha no campo acima a palavra CONFIRMAR');
	              } else {
	                u.$delete({id:u.id},function(){
	                  var idx = $scope.patients.indexOf(u);
	                  $scope.patients.splice(idx);
	                  swal({
	                    title : "Removido paciente com sucesso",
	                    type : "success"
	                  });
	                },
	                function(){
	                  swal({
	                    title : "Erro ao remover paciente",
	                    type : "error"
	                  })
	                });
	              }
	            });
	          }
	        })
		}

		$scope.openForm = function(ev,patient){
		    $mdDialog.show({
		      controller: 'AdminResearchCtrl',
		      templateUrl: 'views/tmpl/admin/research.html',
		      parent: angular.element(document.body),
		      targetEvent: ev,
		      clickOutsideToClose:true,
		      fullscreen: true, // Only for -xs, -sm breakpoints.
	        resolve : {
	          Patient :  function(){ return patient }
	        }
		    })
		    .then(function() {
		    	
		    });
		}
  });
