'use strict';
app
	.controller('AdminResearchViewCtrl', function($scope,PatientFormResource,$localStorage,Research,$mdDialog,_C,Cid10Resource,DrugResource,$filter,toastr) {
		$scope.editing = true;
    $scope.research = PatientFormResource.get({id:Research.id},
			function(){
        $scope.patient = angular.copy($scope.research.Patient);
        $scope.research.Patient = undefined;
        $scope.research.User = undefined;
        if(!$scope.research.PatientDemographic || angular.isUndefined($scope.research.PatientDemographic)){
            $scope.research.PatientDemographic = { family_incomes:"", roommates:""};
        }
        else{
            $scope.research.PatientDemographic.PatientForm = undefined;
        }
        if(!$scope.research.PatientHabits || angular.isUndefined($scope.research.PatientHabits)){
            $scope.research.PatientHabits = { moderated_week:"", moderated_time_day:""};
        }
        else{
            $scope.research.PatientHabits.PatientForm = undefined;
        }
        if(!$scope.research.PatientClinical || angular.isUndefined($scope.research.PatientClinical)){
            $scope.research.PatientClinical = { };
        }
        else{
            $scope.research.PatientClinical.PatientForm = undefined;
        }
        if(!$scope.research.PatientComorbid || angular.isUndefined($scope.research.PatientComorbid)){
            $scope.research.PatientComorbid = [];
        }
        else{
            if(angular.isArray($scope.research.PatientComorbid)){
                angular.forEach($scope.research.PatientComorbid, function(o){
                   o.description = o.Cid10.description;
                   o.id = o.Cid10.id;
                   o.Cid10 = undefined;
                   o.PatientForm = undefined;
                });
            }
            else{
                var o = angular.copy($scope.research.PatientComorbid);
                o.description = o.Cid10.description;
                o.id = o.Cid10.id;
                o.PatientForm = undefined;
                o.Cid10 = undefined;
                $scope.research.PatientComorbid = [];
                $scope.research.PatientComorbid.push(o);
            }
        }
        if(!$scope.research.PatientDrug || angular.isUndefined($scope.research.PatientDrug)){
            $scope.research.PatientDrug = [];
        }
        else{
            if(angular.isArray($scope.research.PatientDrug)){
                angular.forEach($scope.research.PatientDrug, function(o){
                   o.name = o.Drug.name;
                   o.unit_type = o.Drug.unit_type;
                   o.id = o.Drug.id;
                   o.Drug = undefined;
                   o.PatientForm = undefined;
                });
            }
            else{
                var o = angular.copy($scope.research.PatientDrug);
                o.name = o.Drug.name;
                o.unit_type = o.Drug.unit_type;
                o.id = o.Drug.id;
                o.PatientForm = undefined;
                $scope.research.PatientDrug = [];
                $scope.research.PatientDrug.push(o);
            }
        }
        if(!$scope.research.PatientComplication || angular.isUndefined($scope.research.PatientComplication)){
            $scope.research.PatientComplication = [];
        }
        else{
            if(angular.isArray($scope.research.PatientComplication)){
                angular.forEach($scope.research.PatientComplication, function(o){
                   o.description = o.Cid10.description;
                   o.id = o.Cid10.id;
                   o.PatientForm = undefined;
                });
            }
            else{
                var o = angular.copy($scope.research.PatientComplication);
                o.description = o.Cid10.description;
                o.id = o.Cid10.id;
                o.PatientForm = undefined;
                $scope.research.PatientComplication = [];
                $scope.research.PatientComplication.push(o);
            }
        }
        if(!$scope.research.PatientQuality || angular.isUndefined($scope.research.PatientQuality)){
            $scope.research.PatientQuality = { };
        }
        else{
            $scope.research.PatientQuality.PatientForm = undefined;
        }
        if(!$scope.research.PatientExam || angular.isUndefined($scope.research.PatientExam)){
            $scope.research.PatientExam = { };
        }
        else{
            $scope.research.PatientExam.PatientForm = undefined;
        }
			});
		$scope._C = _C;
    $scope.cid10 = Cid10Resource.query();
    $scope.drugs = DrugResource.query();

    /*CONFIGURAR WATCHERS*/
    /*Renda Familiar*/
    $scope.$watch("research.PatientDemographic.family_incomes",function(){
        if($scope.research.PatientDemographic)
            $scope.research.PatientDemographic.incomes_person = $scope.research.PatientDemographic.family_incomes/$scope.research.PatientDemographic.roommates;
    });
    $scope.$watch("research.PatientDemographic.roommates",function(){
        if($scope.research.PatientDemographic)
            $scope.research.PatientDemographic.incomes_person = $scope.research.PatientDemographic.family_incomes/$scope.research.PatientDemographic.roommates;
    });
    /*Frequencia de exercícios moderados*/
    var moderatedWeek = function(){
        if($scope.research.PatientHabits){
            if($scope.research.PatientHabits.moderated_sports_week && $scope.research.PatientHabits.moderated_sports_time){
              var testeData = angular.copy($scope.research.PatientHabits.moderated_sports_time);
                if(!angular.isDate(testeData)){
                    testeData = new Date(testeData*1000);
                }
                var h = testeData.getHours();
                var m = testeData.getMinutes();
                var total = (h*60)+parseInt(m);
                var total_week = total*$scope.research.PatientHabits.moderated_sports_week;
                h = Math.floor(total_week/60);
                m = total_week%60;
                var d = angular.copy(testeData);
                d.setHours(h);
                d.setMinutes(m);
                $scope.research.PatientHabits.moderated_time_week = d;
            }
            else{
                $scope.research.PatientHabits.moderated_time_week = "";
            }
        }
    }
    $scope.$watch("research.PatientHabits.moderated_sports_week",function(){
        moderatedWeek();
    });
    $scope.$watch("research.PatientHabits.moderated_sports_time",function(){
        moderatedWeek();
    });
    /*Frequencia de exercícios vigorosos*/
    var forceWeek = function(){
        if($scope.research.PatientHabits){
            if($scope.research.PatientHabits.high_sports_week && $scope.research.PatientHabits.high_sports_time){
              var testeData = angular.copy($scope.research.PatientHabits.high_sports_time);
                if(!angular.isDate(testeData)){
                    testeData = new Date(testeData*1000);
                }
                var h = testeData.getHours();
                var m = testeData.getMinutes();
                var total = (h*60)+parseInt(m);
                var total_week = total*$scope.research.PatientHabits.high_sports_week;
                h = Math.floor(total_week/60);
                m = total_week%60;
                var d = angular.copy(testeData);
                d.setHours(h);
                d.setMinutes(m);
                $scope.research.PatientHabits.force_time_week = d;
            }
            else{
                $scope.research.PatientHabits.force_time_week = "";
            }
        }
    }
    $scope.$watch("research.PatientHabits.high_sports_week",function(){
        forceWeek();
    });
    $scope.$watch("research.PatientHabits.high_sports_time",function(){
        forceWeek();
    });
    /**/
    /*Total do IMC*/
    var calcImc = function(){
        if($scope.research.PatientExam){
            if($scope.research.PatientExam.weight && $scope.research.PatientExam.height){
                var altura = $scope.research.PatientExam.height/100; // de cm para metro
                var peso =$scope.research.PatientExam.weight;
                var total = peso/(altura*altura);
                $scope.research.PatientExam.imc_value = total;
            }
            else{
                $scope.research.PatientExam.imc_value = "";
            }
        }
    }
    $scope.$watch("research.PatientExam.weight",function(){
        calcImc();
    });
    $scope.$watch("research.PatientExam.height",function(){
        calcImc();
    });

	$scope.searchComorbid = function(query){
      if(query.length>2){
          var que = $scope.cid10;
          que = $filter("filter")(que,{description:query});
          var retorno = [];
          if($scope.research.PatientComorbid){
              var obj ;
              var idx;
              angular.forEach($scope.research.PatientComorbid, function(o){
                  obj = $filter("filter")(que,{id:o.id});
                  if(obj.length>0){
                      idx = que.indexOf(obj[0]);
                      que.splice(idx,1);
                  }
              });
          }
          return que
      }
      return [];    
	}
	$scope.searchComplication = function(query){
      if(query.length>2){
          var que = $scope.cid10;
          que = $filter("filter")(que,{description:query});
          var retorno = [];
          if($scope.research.PatientComplication){
              var obj ;
              var idx;
              angular.forEach($scope.research.PatientComplication, function(o){
                  obj = $filter("filter")(que,{id:o.id});
                  if(obj.length>0){
                      idx = que.indexOf(obj[0]);
                      que.splice(idx,1);
                  }
              });
          }
          return que
      }
      return [];    
	}
	$scope.searchDrug = function(query){
      if(query.length>2){
          var que = $scope.drugs;
          que = $filter("filter")(que,{name:query});
          var retorno = [];
          if($scope.research.PatientDrug){
              var obj ;
              var idx;
              angular.forEach($scope.research.PatientDrug, function(o){
                  obj = $filter("filter")(que,{id:o.id});
                  if(obj.length>0){
                      idx = que.indexOf(obj[0]);
                      que.splice(idx,1);
                  }
              });
          }
          return que
      }
      return [];    
	}
    $scope.transformChip = function(chip) {
      if (angular.isObject(chip)) {
        return chip;
      }
    }

  $scope.confirmarAlteracao = function(){
    $scope.research.$update({id:$scope.research.id},function(data){
      $mdDialog.hide(true);
      toastr.success("Formulário alterado com sucesso",{timeOut:3000});
    },
    function(data){
      console.log(data);
    })
  }
});
