'use strict';
/**
 * @ngdoc function
 * @name sbAdminApp.controller:MainCtrl
 * @description
 * # MainCtrl
 * Controller of the sbAdminApp
 */
app
  .controller('AdminProfileCtrl', function($scope,$uibModal,UsuarioResource,DepartamentoResource,$http,toastr,Usuario) {
    $scope.usuario = angular.copy(Usuario);
    $scope.departamentos = DepartamentoResource.query();

    /*modals****************************************************************/
    $scope.openModal = function() {
        var modalInstance = $uibModal.open({
          templateUrl: 'modalContent.html',
          controller: 'FormImgCropCtrl',
          size: 'lg'
        });
        modalInstance.result.then(function (img) {
          if(img){
            $scope.usuario.Pessoa.foto = img;
          }
        }, function () {
          // $log.info('Modal dismissed at: ' + new Date());
        });
    };

    $scope.loadCep = function(){
      $http({
          method: 'GET',
          url: 'http://viacep.com.br/ws/'+$scope.usuario.Pessoa.cep.replace("-","")+'/json/',
          headers: { 
              'Apikey': undefined
          }
      }).then(function successCallback(response) {
          var end = response.data;
          $scope.usuario.Pessoa.logradouro = end.logradouro;
          $scope.usuario.Pessoa.uf = end.uf;
          $scope.usuario.Pessoa.cidade = end.localidade;
      });
    };

    $scope.save = function(){
      $scope.usuario.$update({id:$scope.usuario.id},function(){
        Usuario = $scope.usuario;
        toastr.success("Atualizado com sucesso",{timeOut:3000})
      },
      function(r){
        angular.forEach(r.data.error, function(e){
          toastr.error(e,{timeOut:3000})
        });
      })
    }

  });
