'use strict';
app
  .controller('CartoesCtrl', function($scope,$cookies,TagResource,Usuario,$uibModal,SweetAlert) {
  	$scope.filter = {};
  	if(Usuario){
  		$scope.filter.search = Usuario.Pessoa.cpf;
  	}
    // $scope.access = [
    // 	{id:"1",name:"XXXXXXX",number:"12321342132131",person_name:"João da Silva",access_date:"01/01/2017 10:15:22"},
    // 	{id:"2",name:"XXXXXXX",number:"15151616516515",person_name:"Judit da Silva",access_date:"03/02/2017 15:15:22"},
    // ]
    $scope.tags = TagResource.query(function(){});

    $scope.remove = function(t){
      SweetAlert.swal({
         html:true,
         title: "Deseja excluir a tag?",
         text: "Essa é uma ação irreversível!<br><br><select class='form-control'><option>Motivo - Fraude</option><option> Motivo - Informações Incompletas</option></select>",
         type: "warning",
         showCancelButton: true,
         confirmButtonColor: "#DD6B55",
         confirmButtonText: "Sim, excluir!",
         showLoaderOnConfirm: true,
         closeOnConfirm: false}, 
          function(isConfirm){ 
            if(isConfirm){
              t.$delete({id:t.id},function(){
               SweetAlert.swal("Excluído","Tag excluída com sucesso!", "success");         
                var idx = $scope.tags.indexOf(t);
                if (idx != -1) {
                    $scope.tags.splice(idx, 1);
                }
              },
              function(r){
                toastr.error("Ocorreu um erro ao excluir a tag",{timeOut:5000});
                angular.forEach(r.data.error, function(e){
                  toastr.error(e,{timeOut:5000});
                });
            })
          }
          });

    }
    $scope.edit = function(t){
        var modalInstance = $uibModal.open({
          templateUrl: 'views/tmpl/admin/novo_cartao.html',
          controller: 'NovoCartaoCtrl',
          size: 'lg',
          resolve : {
            Cartao : function (){ return t}
          }
        });
        modalInstance.result.then(function (img) {
          if(img){
            $scope.tags = TagResource.query(function(){});
            // $scope.tags.push(img);
          }
        }, function () {
          // $log.info('Modal dismissed at: ' + new Date());
        });
    }
    $scope.newCard =function(){
        var modalInstance = $uibModal.open({
          templateUrl: 'views/tmpl/admin/novo_cartao.html',
          controller: 'NovoCartaoCtrl',
          size: 'lg',
          resolve : {
            Cartao : {
              Usuario : Usuario
            }
          }
        });
        modalInstance.result.then(function (img) {
          if(img){
            $scope.tags.push(img);
          }
        }, function () {
          // $log.info('Modal dismissed at: ' + new Date());
        });
    }
    $scope.openAccess = function(card){
        var modalInstance = $uibModal.open({
          templateUrl: 'views/tmpl/admin/acessos.html',
          controller: 'AcessosCtrl',
          size: "lg",
          resolve : {
            card : function(){
              return card;
            }
          }
        });
    }
});
