'use strict';
app
  .controller('ClientesCtrl', function($scope,$cookies,UsuarioResource,$uibModal,SweetAlert,toastr) {
    $scope.filter = {};
    $scope.clientes = UsuarioResource.query();

    $scope.edit =function (a){
      var modalInstance = $uibModal.open({
        templateUrl: 'views/tmpl/admin/user_profile.html',
        controller: 'AdminProfileCtrl',
        size: 'lg',
        resolve : {
          Usuario :  function(){ return a }
        }
      });
      modalInstance.result.then(function (img) {
        $scope.clientes = UsuarioResource.query();
        // if(img){
        //   $scope.usuario.Pessoa.foto = img;
        // }
      }, function () {
        // $log.info('Modal dismissed at: ' + new Date());
      });
    }
    $scope.tags = function(cliente){
        var modalInstance = $uibModal.open({
          templateUrl: 'views/tmpl/admin/cartoes.html',
          controller: 'CartoesCtrl',
          size: "lg",
          resolve : {
            Usuario : function(){return cliente}
          }
        });
    }
    $scope.remove = function(c){
      SweetAlert.swal({
         html:true,
         title: "Deseja excluir o cliente?",
         text: "Essa é uma ação irreversível!<br><br><select class='form-control'><option>Motivo - Fraude</option><option> Motivo - Informações Incompletas</option></select>",
         type: "warning",
         showCancelButton: true,
         confirmButtonColor: "#DD6B55",
         confirmButtonText: "Sim, excluir!",
         showLoaderOnConfirm: true,
         closeOnConfirm: false}, 
          function(isConfirm){ 
            if(isConfirm){
              c.$delete({id:c.id},function(){
               SweetAlert.swal("Excluído","Usuário excluído com sucesso!", "success");         
                var idx = $scope.clientes.indexOf(c);
                if (idx != -1) {
                    $scope.clientes.splice(idx, 1);
                }
              },
              function(r){
                toastr.error("Ocorreu um erro ao excluir o cliente",{timeOut:5000});
                angular.forEach(r.data.error, function(e){
                  toastr.error(e,{timeOut:5000});
                });
            })
          }
          });
    }
    $scope.lock = function(c){
      SweetAlert.swal({
         title: "Deseja bloquear o cliente?",
         text: "Ele não poderá mais entrar!",
         type: "warning",
         showCancelButton: true,
         confirmButtonColor: "#DD6B55",
         confirmButtonText: "Sim, bloquear!",
         showLoaderOnConfirm: true,
         closeOnConfirm: false}, 
          function(isConfirm){ 
            if(isConfirm){
              c.aprovado = '0';
              c.$update({id:c.id},function(){
               SweetAlert.swal("Bloqueado","Bloqueado!", "success");         
              },
              function(r){
                toastr.error("Ocorreu um erro ao bloquear o cliente",{timeOut:5000});
                angular.forEach(r.data.error, function(e){
                  toastr.error(e,{timeOut:5000});
                });
            })
          }
          });
    }
    $scope.unlock = function(c){
      SweetAlert.swal({
         title: "Deseja desbloquear o cliente?",
         text: "Ele voltará a ter acesso !",
         type: "warning",
         showCancelButton: true,
         confirmButtonColor: "#7AB12C",
         confirmButtonText: "Sim, desbloquear!",
         showLoaderOnConfirm: true,
         closeOnConfirm: false}, 
          function(isConfirm){ 
            if(isConfirm){
              c.aprovado = '1';
              c.$update({id:c.id},function(){
               SweetAlert.swal("Desbloquear","Desbloqueado!", "success");         
              },
              function(r){
                toastr.error("Ocorreu um erro ao desbloquear o cliente",{timeOut:5000});
                angular.forEach(r.data.error, function(e){
                  toastr.error(e,{timeOut:5000});
                });
            })
          }
          });
    }

})  .controller('ClientesModalCtrl', function($scope,$cookies,UsuarioResource,$uibModal,SweetAlert,toastr,$uibModalInstance) {
  	$scope.filter = {};
    $scope.clientes = UsuarioResource.query();

    $scope.selecionarCliente = function(c){
       $uibModalInstance.close(c);
    }
});
