'use strict';
app
  .controller('LoginCtrl', function($translate,$scope,$localStorage,$state,AuthenticationService,toastr, $timeout) {
    AuthenticationService.ClearCredentials();
    $scope.user = {};
    $scope.user.email = "";
    $scope.user.password = "";

    $scope.valid = function(){
      var vl= 1;
      angular.forEach($scope.user, function(v,k){
        if(v=="" || v==undefined){
          vl= 0;
          toastr.error($translate.instant("signup.validation."+k), {timeOut: 5000})
        }
      });
      $timeout(function(){
        if(vl){$scope.login()}}, 100);
    }

  	$scope.login = function(){
      AuthenticationService.Login($scope.user.email, $scope.user.password, function(response) {
          if(response.status==200){
              if(response.data.id>0){
                AuthenticationService.SetCredentials(response.data.id, response.data.apikey);
                toastr.success($translate.instant('login.success'),{timeOut:1000});
                  $state.transitionTo('dashboard.home');
              }
              else{
                response.message = $translate.instant('login.fail');
              }
          } else {
              if(response.status==401){
                  response.message = $translate.instant('login.fail');
              }
              else{
                  response.message = response.message = $translate.instant('connection.fail');
              }
              toastr.error(response.message,{timeOut:1000});
              AuthenticationService.ClearCredentials();
          }
      });
  	}
});