'use strict';
app
  .controller('ProfileCtrl', function($rootScope, $scope, UserResource, $cookies, $translate, $timeout, $filter, AuthenticationService, toastr) {
    var validation = 1;
    $scope.user = {};
    $scope.button = {};
    $scope.form ={};
    $scope.button.disabled = false;
    $scope.button.visible = false;
    UserResource.get({id:$cookies.get("id")}, function(data){
      data.allow_notify ? true : false; 
      $scope.user = data;
      $scope._user = angular.copy($scope.user);  
    });
    var msg = [];

    $scope.change = function(){
      $scope.button.disabled = true; //disable button
      validation = 1;
      var changedPassword = false;
      if($scope.user.new_password != "" && !angular.isUndefined($scope.user.new_password)){
        if(!angular.equals($scope.user.new_password, $scope.user.confirm_password)){
          msg.push("signup.validation.password_match");
          validation = 0;
        }
        else{
          changedPassword = true;
        }
      }
      if($scope.user.name == "" || angular.isUndefined($scope.user.name)){
        msg.push("signup.validation.name");
        validation = 0;
      }
      
      if(msg.length){
        toastr.error(msg);
        msg = [];
      }

      $timeout(function(){
        var _em = $scope.user.email;
        var _np = angular.copy($scope.user.new_password); //because when the user.update is successfull already update the model.
        if(validation){
          swal({
            title: $translate.instant("profile.information.save.title"),
            text: $translate.instant("profile.information.save.text"),
            type: 'question',
            input: 'password',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: $translate.instant("profile.button.change_profile"),
            cancelButtonText: $translate.instant("other.cancelSweet"),
            showLoaderOnConfirm : true,
            preConfirm: function(pass){
                return new Promise(function(resolve, reject) {
                  if (pass=="") {
                    reject($translate.instant("profile.information.save.confirmTextError"));
                  } else {
                    $scope.user.old_password = pass;
                    $scope.user.$update({id:$cookies.get("id")}, function(data) {
                      if(changedPassword){
                        AuthenticationService.SetCredentials($cookies.get("id"), 0, _em, _np);            
                      }
                      $scope.button.disabled = false; //enable button
                      $scope.button.visible = false;
                      $scope.user = data;
                      $rootScope.user.name = data.name;
                      swal({
                        title : $translate.instant("profile.information.success"),
                        type : "success"
                      });
                    },
                    function (err) {
                      var msg = "";
                      angular.forEach(err.data, function(v){
                        msg += v;
                      });
                      swal({
                        title : msg,
                        type : "error"
                      })
                      $scope.button.disabled = false; 
                    });
                  }
                });
              }
            })

        }else{
          $scope.button.disabled = false; //enable button
        }
      }, 200);
    }


  });
